function CEndPanel(oSpriteBg) {

    var _oBg;
    var _oTitleText;
    var _oTotScore;
    var _oTotScore;
    var _oTitleText;
    var _oGroup;
    var _oButMenu;
    var _oButRestart;
    var _oButContinue;
    var _oFade;

    this._init = function (oSpriteBg) {
        var iSizeFontSecondaryText = 46;

        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);
        _oFade.alpha = 0.0;

        s_oStage.addChild(_oFade);

        _oGroup = new createjs.Container();
        _oGroup.alpha = 1;
        _oGroup.visible = false;
        _oGroup.y = CANVAS_HEIGHT;

        _oBg = createBitmap(oSpriteBg);
        _oBg.x = CANVAS_WIDTH_HALF;
        _oBg.y = CANVAS_HEIGHT_HALF;
        _oBg.regX = oSpriteBg.width * 0.5;
        _oBg.regY = oSpriteBg.height * 0.5;
        _oGroup.addChild(_oBg);

        _oTitleText = new createjs.Text("", "50px " + PRIMARY_FONT, TEXT_COLOR);
        _oTitleText.x = CANVAS_WIDTH / 2;
        _oTitleText.y = CANVAS_HEIGHT_HALF - 180;
        _oTitleText.textAlign = "center";

        _oGroup.addChild(_oTitleText);

        _oTotScore = new createjs.Text("", iSizeFontSecondaryText + "px " + PRIMARY_FONT, TEXT_COLOR);
        _oTotScore.x = CANVAS_WIDTH / 2;
        _oTotScore.y = (CANVAS_HEIGHT / 2) - 60;
        _oTotScore.textAlign = "center";

        _oGroup.addChild(_oTotScore);

        var oSpriteButRestart = s_oSpriteLibrary.getSprite("but_restart");
        _oButRestart = new CGfxButton(CANVAS_WIDTH * 0.5 - 180, CANVAS_HEIGHT * 0.5 + 110, oSpriteButRestart, _oGroup);
        _oButRestart.addEventListener(ON_MOUSE_DOWN, this._onRestart, this);
        _oButRestart.pulseAnimation();

        var oSpriteButHome = s_oSpriteLibrary.getSprite("but_home");
        _oButMenu = new CGfxButton(CANVAS_WIDTH * 0.5 + 180, CANVAS_HEIGHT * 0.5 + 110, oSpriteButHome, _oGroup);
        _oButMenu.addEventListener(ON_MOUSE_DOWN, this._onExit, this);

        var oSpriteButContinue = s_oSpriteLibrary.getSprite("but_continue");
        _oButContinue = new CGfxButton(CANVAS_WIDTH * 0.5, CANVAS_HEIGHT * 0.5 + 110, oSpriteButContinue, _oGroup);
        _oButContinue.addEventListener(ON_MOUSE_DOWN, this._onContinue, this);


        s_oStage.addChild(_oGroup);

    };

    this.unload = function () {
        if (_oButMenu) {
            _oButMenu.unload();
            _oButMenu = null;
        }

        if (_oButRestart) {
            _oButRestart.unload();
            _oButRestart = null;
        }
        _oFade.removeAllEventListeners();
        s_oStage.removeChild(_oGroup, _oFade);
    };

    this.show = function (iScore) {
        _oTitleText.text = TEXT_WIN;

        _oTotScore.text = TEXT_TOTAL_SCORE + ": " + iScore;

        _oGroup.visible = true;

        createjs.Tween.get(_oFade).to({alpha: 0.5}, 500, createjs.Ease.cubicOut);

        createjs.Tween.get(_oGroup).wait(250).to({y: 0}, 1250, createjs.Ease.bounceOut).call(function () {
            if (s_oAdsLevel === NUM_LEVELS_FOR_ADS) {
                $(s_oMain).trigger("show_interlevel_ad");
                s_oAdsLevel = 1;
            } else {
                s_oAdsLevel++;
            }
        });

        $(s_oMain).trigger("save_score", iScore);
        $(s_oMain).trigger("share_event", iScore);
    };

    this._onContinue = function () {
        this.createFade(this.onUnloadContinue);
    };

    this.createFade = function (oFunction) {
        var oFade = new createjs.Shape();
        oFade.graphics.beginFill("black").drawRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);
        oFade.alpha = 0.0;

        s_oStage.addChild(oFade);

        var oParent = this;

        createjs.Tween.get(oFade).to({alpha: 1}, 750, createjs.Ease.cubicOut).call(function () {
            s_oStage.removeChild(oFade);
            oFunction(oParent);
        });
    };

    this._onRestart = function () {
        this.createFade(this.onUnloadRestart);
    };

    this.onUnloadRestart = function (oParent) {
        oParent.unload();
        s_oGame.restartLevel();

    };

    this.onUnloadContinue = function (oParent) {
        oParent.unload();
        s_oGame.unload();
        s_oMain.gotoLevelMenu();
        $(s_oMain).trigger("end_level", 1);
        $(s_oMain).trigger("end_session");
        $(s_oMain).trigger("show_interlevel_ad");
        setVolume(s_oSoundTrack, 1);
    };

    this.onUnloadExit = function (oParent) {
        oParent.unload();
        s_oGame.onExit();
    };

    this._onExit = function () {
        this.createFade(this.onUnloadExit);
    };

    this._init(oSpriteBg);

    return this;
}